function [final_score] = compute_score4_3_level(bitPlanesA,bitPlanesB)
%Rotating Planes A, Shifting Planes B
[rows, cols, p] = size(bitPlanesA);
shiftLength_i = ceil(rows*0.25); 
shiftLength_j = ceil(cols*0.25); 
score = ones(2*shiftLength_i+1,2*shiftLength_j+1,21);

for degree = -10:1:10
    bitPlanesA_R = bitPlanesA;
    for p_i = 1:p
    bitPlanesA_R(:,:,p_i) = imrotate(bitPlanesA(:,:,p_i),degree,'crop');
    end

    for shifti = -shiftLength_i:shiftLength_i
        for shiftj = -shiftLength_j:shiftLength_j
            new_bitPlanesA = bitPlanesA_R(1+shiftLength_i:rows-shiftLength_i,1+shiftLength_j:cols-shiftLength_j,:);%constant center part
            new_bitPlanesB = bitPlanesB(1+shiftLength_i+shifti:rows-shiftLength_i+shifti,1+shiftLength_j+shiftj:cols-shiftLength_j+shiftj,:);
            
            Planes = abs(new_bitPlanesA-new_bitPlanesB)/2;
            score(shifti+shiftLength_i+1,shiftj+shiftLength_j+1,degree+11) = length(find(Planes==1))/(length(find(Planes==0))+length(find(Planes==1)));
        end
    end
end
final_score = min(score(:));

end