type = 'forefinger';
session = 1;
basedir1 = 'data/subject';
out_dir1 = 'feature/subject';
downsample_factor = 0.1980/0.4235; %for getting [70x100] depth map for matching
basedir2 = ['/session' num2str(session) '/' type '/set'];

ssc = @(v) [0 -v(3) v(2); v(3) 0 -v(1); -v(2) v(1) 0];
RU = @(A,B) eye(3) + ssc(cross(A,B)) + ssc(cross(A,B))^2*(1-dot(A,B))/(norm(cross(A,B))^2);

for subjectID = 1:2
    for setID = 1:2
        disp([num2str(subjectID) ',' num2str(setID) '...'])
        load([basedir1 num2str(subjectID) basedir2 num2str(setID) '/surfNormal.mat']);
        N = reshape(surfNormal,212,149,3);
        N = imresize(N, downsample_factor);
        N2 = permute(N,[2 1 3]);
        N2(:,:,3) = -N2(:,:,3);
            
        %% Surfae Normal Directions
        snd1 = 2*ones(70,100);
        snd2 = 2*ones(70,100);
        snd3 = 2*ones(70,100);
        snd4 = 2*ones(70,100);
        for i = 1+2:70-2
            for j = 1+2:100-2
                R = RU(squeeze(N2(i,j,:)),[0,0,1]);

                v1 = R*squeeze(N2(i,j-1,:));
                v2 = R*squeeze(N2(i,j+1,:));
                if(v2(1)<0&&v1(1)>0)
                    b(1) = 1;
                elseif(v2(1)>0&&v1(1)<0)
                    b(1) = 3;
                else
                    b(1) = 2;
                end

                v1 = R*squeeze(N2(i-1,j,:));
                v2 = R*squeeze(N2(i+1,j,:));
                if(v2(2)<0&&v1(2)>0)
                    b(2) = 1; 
                elseif(v2(2)>0&&v1(2)<0)
                    b(2) = 3; 
                else
                    b(2) = 2;
                end

                v1 = R*squeeze(N2(i-1,j-1,:));
                x = v1(1); y = v1(2);
                a1 = sqrt(x^2+y^2-(x-y)^2/2)*sign(x+y);
                v2 = R*squeeze(N2(i+1,j+1,:));
                x = v2(1); y = v2(2);
                a2 = sqrt(x^2+y^2-(x-y)^2/2)*sign(x+y);
                if(a2<0&&a1>0)
                    b(3) = 1; 
                elseif(a2>0&&a1<0)
                    b(3) = 3;
                else
                    b(3) = 2;
                end

                v1 = R*squeeze(N2(i-1,j+1,:));
                x = v1(1); y = v1(2);
                a1 = sqrt(x^2+y^2-(x+y)^2/2)*sign(-x+y);
                v2 = R*squeeze(N2(i+1,j-1,:));
                x = v2(1); y = v2(2);
                a2 = sqrt(x^2+y^2-(x+y)^2/2)*sign(-x+y);
                if(a2<0&&a1>0)
                    b(4) = 1;
                elseif(a2>0&&a1<0)
                    b(4) = 3;
                else
                    b(4) = 2;
                end

                snd1(i,j) = b(1);
                snd2(i,j) = b(2);
                snd3(i,j) = b(3);
                snd4(i,j) = b(4);
            end
        end
        %imshow([snd1 snd2 snd3 snd4],[])
        
        mkdir([out_dir1 num2str(subjectID) basedir2 num2str(setID)]);
        save([out_dir1 num2str(subjectID) basedir2 num2str(setID) '/snd.mat'],'snd1','snd2','snd3','snd4')
    end
end